"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Invoke = void 0;
var express = require("express");
var ajaxHelper_1 = require("../../Helpers/ajaxHelper");
var constants_1 = require("../../Helpers/constants");
var xmsPathQuery = "x-ms-path-query";
var Invoke;
(function (Invoke) {
    "use strict";
    Invoke.serverRouter = express.Router();
    Invoke.serverRouter.all("/", function (req, res, next) {
        var queryPath = req.headers[xmsPathQuery];
        if (queryPath) {
            ajaxHelper_1.AjaxHelper.loopbackAjax(req, decodeURIComponent(queryPath.toString())).then(function (proxyRes) {
                Object.keys(proxyRes.headers).forEach(function (key) {
                    if (proxyRes.headers[key] != undefined) {
                        res.setHeader(String(key).trim(), proxyRes.headers[key]);
                    }
                });
                res.writeHead(proxyRes.statusCode);
                // copy body from the proxy response to the response
                proxyRes.pipe(res);
            }, function (err) {
                res.status(constants_1.Constants.HttpStatusCode.InternalServerError).send(err || "Unknown");
            });
        }
        else {
            next();
        }
    });
})(Invoke = exports.Invoke || (exports.Invoke = {}));
//# sourceMappingURL=invoke.js.map