"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Subscriptions = void 0;
var armHelper_1 = require("../armHelper");
var constants_1 = require("../../Helpers/constants");
var urlParams_1 = require("./urlParams");
var Subscriptions;
(function (Subscriptions) {
    "use strict";
    /**
     * Initializes the routes.
     *
     * @param app The express app.
     */
    function init(app) {
        app.get("/subscriptions", function (req, res, next) {
            armHelper_1.ArmHelper.handleRequest(req, res, next, function (armManager) {
                armHelper_1.ArmHelper.proxyReq(req, res, []).then(function (subs) {
                    var mockSubs = !armManager ? [] : armManager.getSubscriptions();
                    var response = {
                        value: subs.concat(mockSubs)
                    };
                    res.status(constants_1.Constants.HttpStatusCode.Ok).json(response);
                }).catch(function (err) {
                    console.error(err);
                });
            });
        });
        app.get("/subscriptions/:" + urlParams_1.UrlParams.Params.subscriptionId, function (req, res, next) {
            var mockSubscriptionId = req[urlParams_1.UrlParams.Params.subscriptionId];
            if (mockSubscriptionId) {
                var armManager = req.app.armManager;
                var sub = armManager.getSubscription(mockSubscriptionId);
                res.status(constants_1.Constants.HttpStatusCode.Ok).json(sub);
            }
            else {
                next();
            }
        });
    }
    Subscriptions.init = init;
})(Subscriptions = exports.Subscriptions || (exports.Subscriptions = {}));
//# sourceMappingURL=subscriptions.js.map