/**
 * The provider interface.
 */
export interface Provider {
    /**
     * Namespace for the provider
     */
    namespace: string;
    /**
     * Resource Types that are provided by the provider.
     */
    resourceTypes: ResourceType[];
    /**
     * Registration state that are provided by the provider.
     */
    registrationState?: string;
}
/**
 * The resource type interface.
 */
export interface ResourceType {
    /**
     * List of locations that the Resource Type has
     */
    locations: string[];
    /**
     * Resource Type name
     */
    resourceType: string;
    /**
     * List of supported api versions.
     */
    apiVersions: string[];
}
