import * as html5 from "../../Helpers/html5";
import StringMap = html5.StringMap;
/**
 * The resources data returned by '/resources' api.
 */
export interface ResourceBase {
    /**
     * Resource id.
     */
    id: string;
    /**
     * Resource name.
     */
    name: string;
    /**
     * Resource tags.
     */
    tags: StringMap<string>;
    /**
     * Resource type.
     */
    type: string;
    /**
     * Resource kind.
     */
    kind: string;
    /**
     * Resource location.
     */
    location: string;
}
export interface Resource extends ResourceBase {
    /**
     * Resource group ID.
     */
    resourceGroup: string;
    /**
     * Resource self link URI.
     */
    selfLinkUri: string;
}
