import * as html5 from "../../Helpers/html5";
import StringMap = html5.StringMap;
/**
 * The locked states enumeration provides named constants for the resource group.
 */
export declare const ResourceLockState: {
    /**
     * Locked resource group.
     */
    Locked: string;
    /**
     * Unlocked resource group.
     */
    Unlocked: string;
};
export interface ResourceGroup {
    /**
     * Resource group id.
     */
    id: string;
    /**
     * Resource group tags.
     */
    tags: StringMap<string>;
    /**
     * Resource group properties.
     */
    properties: ResourceGroupProperties;
    /**
     * Resource group location.
     */
    location: string;
    /**
     * Resource group name.
     */
    name: string;
}
/**
 * Resource group properties.
 */
export interface ResourceGroupProperties {
    /**
     * Resource group lock state.
     */
    lockState: string;
    /**
     * Resource group provisioning state.
     */
    provisioningState: string;
}
