/**
 * Data contract for a single Azure subscription.
 */
export interface Subscription {
    /**
     * Subscription resource id.
     */
    id: string;
    /**
     * Friendly name of the azure subscription.
     */
    displayName: string;
    /**
     * Id of the azure subscription.
     */
    subscriptionId: string;
    /**
     * The subscription state.
     */
    state: string;
    /**
     * The subscription policies. May be null.
     */
    subscriptionPolicies?: SubscriptionPolicies;
}
/**
 * Data contract for Azure subscription policies.
 */
export interface SubscriptionPolicies {
    /**
     * The subscription location placement id.
     */
    locationPlacementId: string;
    /**
     * The subscription quota id.
     */
    quotaId: string;
}
