import * as Q from "q";
import * as express from "express";
export declare module AjaxHelper {
    /**
     * Forward the passed in request to the passed in host and returns the response.
     *
     * @param request The incoming request to forward.
     * @param host The target host.
     * @param port The target host port.
     * @return A promise that will resolve with the response body from the forwarded request.
     */
    function fwdAjax(request: any, host: string, port?: number): Q.Promise<any>;
    /**
     * Forwards the request back to the same host but a different path.
     *
     * @param request The incoming request to forward.
     * @param port The target host port.
     * @param method The forward request method.
     * @return A promise that will resolve with the response body from the forwarded request.
     */
    function loopbackAjax(request: express.Request, path: string, method?: string): Q.Promise<any>;
    /**
     * Gets the JSON data from the body of the response. If it fails to parse as valid JSON, the original data will be returned.
     *
     * @param response The response object.
     * @return A promise that is resolved with the data.
     */
    function getJsonData(response: any): Q.Promise<any>;
}
