"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPlugin = void 0;
var fs_1 = require("fs");
var path_1 = require("path");
var plugin = fs_1.readFileSync(path_1.join(__dirname, "plugin.js"), {
    encoding: "utf8",
});
function getPlugin(targets, runId, testId, port) {
    var hosts = [];
    var config = {
        hosts: hosts.concat.apply(hosts, targets.map(function (target) { return target.hosts; })),
        port: port,
        runId: runId,
        testId: testId,
    };
    return (plugin
        // Remove TypeScript-generated exports
        .replace(/.*Object.defineProperty.*/, "")
        // Update config block
        .replace(/\/\* %CONFIG[\s\S]*?CONFIG% \*\//, "const config = " + JSON.stringify(config) + ";")
        // Remove TypeScript-generated source map since it'll be wrong
        .replace(/\/\/# sourceMap.*/, ""));
}
exports.getPlugin = getPlugin;
//# sourceMappingURL=index.js.map