/// <reference types="node" />
export interface SSLCertificate {
    pfx: Buffer;
    passphrase: string;
}
/**
 * Executes "createCert.ps1" which either returns the existing MockFx certificate and passphrase or creates one if it doesn't exist.
 */
export declare function getSSLCertificate(): Promise<SSLCertificate>;
/**
 * Injects the server CA into the TLS context since NodeJS doesn't use the Windows cert store
 */
export declare function loadWinCAs(): void;
/**
 * Adds a firewall rule to open up a local port for mock server.
 *
 * @param port The local port that should be opened
 */
export declare function addFirewallRule(port: number): Promise<void>;
/**
 * Removes a firewall rule.
 *
 * @param name The name of the rule.
 */
export declare function removeFirewallRule(): Promise<void>;
