"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AzureAsyncReducer = void 0;
/*
    To understand the call patterns please read below.
    https://docs.microsoft.com/azure/azure-resource-manager/management/async-operations
*/
var AzureAsyncReducer = /** @class */ (function () {
    function AzureAsyncReducer() {
    }
    AzureAsyncReducer.prototype.reduce = function (requests) {
        var operations = requests.filter(function (val) {
            return Object.keys(val.responseHeaders).indexOf("Azure-AsyncOperation") >= 0;
        }).map(function (val) {
            var url = val.responseHeaders["Azure-AsyncOperation"];
            return url.indexOf("/subscriptions") >= 0
                ? url.match("(?=\/subscriptions).*")[0]
                : url;
        });
        return requests.reduce(function (acc, req) {
            var shouldSkip = operations.includes(req.url)
                && Object.keys(req.response).indexOf("status") >= 0
                && (req.response["status"] === "Pending"
                    || req.response["status"] === "InProgress");
            if (!shouldSkip) {
                acc.push(req);
            }
            return acc;
        }, []);
    };
    return AzureAsyncReducer;
}());
exports.AzureAsyncReducer = AzureAsyncReducer;
//# sourceMappingURL=AzureAsyncReducer.js.map