"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeploymentReducer = void 0;
var DeploymentReducer = /** @class */ (function () {
    function DeploymentReducer() {
    }
    DeploymentReducer.prototype.reduce = function (requests) {
        var deployments = [];
        return requests.reduce(function (acc, req) {
            var deployment = deployments.find(function (dep) { return req.url.startsWith(dep.url); });
            if (deployment) {
                if (!deployment.successCommands) {
                    deployment.successCommands = requests.reduce(function (lastAcc, lastReq) {
                        if (lastReq.url.startsWith(deployment.url) &&
                            lastReq.metadata.command &&
                            lastReq.metadata.command.startsWith("fx.Deploy.pollForUpdates.attempt") &&
                            lastReq.response.properties.provisioningState === "Succeeded") {
                            lastReq.metadata.command = "fx.Deploy.pollForUpdates.attemptLast";
                            lastAcc.successfulAttempt = JSON.parse(JSON.stringify(lastReq));
                        }
                        if (lastReq.url.startsWith(deployment.url) &&
                            lastReq.metadata.command === "HubsExtension.DeploymentDetailsBlade.fetchDeployment") {
                            lastAcc.successfulDeployment1 = lastReq;
                        }
                        if (lastReq.url.startsWith(deployment.url) &&
                            lastReq.metadata.command === "HubsExtension.DeploymentDetailsOverviewV2.fetchDeployment" &&
                            lastReq.response.properties.provisioningState === "Succeeded") {
                            lastAcc.successfulDeployment2 = lastReq;
                        }
                        if (lastReq.url.startsWith(deployment.url) &&
                            lastReq.metadata.command === "HubsExtension.DeploymentDetailsOverviewV2.fetchOperations" &&
                            lastReq.response.value.every(function (val) { return val.properties.provisioningState === "Succeeded"; })) {
                            lastAcc.successfulOperation = lastReq;
                        }
                        return lastAcc;
                    }, {});
                }
                if (req.metadata.command &&
                    (req.metadata.command.startsWith("fx.Deploy.pollForUpdates.attempt") ||
                        req.metadata.command === "HubsExtension.DeploymentDetailsBlade.fetchDeployment" ||
                        req.metadata.command === "HubsExtension.DeploymentDetailsOverviewV2.fetchDeployment" ||
                        req.metadata.command === "HubsExtension.DeploymentDetailsOverviewV2.fetchOperations")) {
                    if (req.metadata.command === "fx.Deploy.pollForUpdates.attempt0") {
                        if (deployment.successCommands.successfulAttempt) {
                            deployment.successCommands.successfulAttempt.metadata.command =
                                "fx.Deploy.pollForUpdates.attempt0";
                            acc.push(deployment.successCommands.successfulAttempt);
                        }
                        deployment.successCommands.successfulDeployment1 &&
                            acc.push(deployment.successCommands.successfulDeployment1);
                        deployment.successCommands.successfulDeployment2 &&
                            acc.push(deployment.successCommands.successfulDeployment2);
                        deployment.successCommands.successfulOperation &&
                            acc.push(deployment.successCommands.successfulOperation);
                    }
                }
                else {
                    acc.push(req);
                }
            }
            else if (req.metadata.command && req.metadata.command.endsWith(".Deploy.submitDeployment")) {
                deployments.push({
                    url: req.url.replace(/\?.*/, ""),
                });
                acc.push(req);
            }
            else if (req.url.toLowerCase().indexOf("operationstatuses") > 0) {
                // We can collapse the in progress statuses
                if (req.response.status.toLowerCase() !== "running") {
                    acc.push(req);
                }
            }
            else {
                acc.push(req);
            }
            return acc;
        }, []);
    };
    return DeploymentReducer;
}());
exports.DeploymentReducer = DeploymentReducer;
//# sourceMappingURL=DeploymentReducer.js.map