"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocationReducer = void 0;
/*
    To understand the call patterns please read below.
    https://docs.microsoft.com/azure/azure-resource-manager/management/async-operations
*/
var LocationReducer = /** @class */ (function () {
    function LocationReducer() {
    }
    LocationReducer.prototype.reduce = function (requests) {
        var operations = requests.filter(function (val) {
            return Object.keys(val.responseHeaders).indexOf("Location") >= 0;
        }).map(function (val) {
            var url = val.responseHeaders["Location"];
            return url.indexOf("/subscriptions") >= 0
                ? url.match("(?=\/subscriptions).*")[0]
                : url;
        });
        return requests.reduce(function (acc, req) {
            var shouldSkip = operations.includes(req.url)
                && req.responseCode == 202;
            if (!shouldSkip) {
                acc.push(req);
            }
            return acc;
        }, []);
    };
    return LocationReducer;
}());
exports.LocationReducer = LocationReducer;
//# sourceMappingURL=LocationReducer.js.map