/// <reference types="node" />
import { NextFunction, Request, Response } from "express";
import { MockFx, _FullContext } from "..";
import { IncomingMessage } from "http";
export declare class Target {
    private context;
    private definition;
    private requests;
    constructor(definition: MockFx.TargetDefinition, context: _FullContext);
    getDefinition(): MockFx.TargetDefinition;
    handleRequest(proxySend: (req: Request, res: Response) => void, req: Request, res: Response, next: NextFunction): Promise<void | Response<any>>;
    handleProxyResponse(request: IncomingMessage, mockRequest: MockFx.Request): Promise<void>;
    snapToStage(stage: string): Promise<void>;
    removeStage(stage: string): Promise<void>;
    onRegister(): Promise<void>;
    loadRequests(): Promise<void>;
    storeRequests(): Promise<void>;
}
