import * as RdfeModel from "./Models/rdfeModel";
export declare module RdfeHelper {
    /**
     * Converts a SubscriptionCertificate array into a xml encoded string.
     * @param certificates
     */
    function convertSubscriptionCertificatesToXml(certificates: RdfeModel.SubscriptionCertificate[]): string;
    /**
     * Converts a SubvscriptionCertificate into a xml encoded string.
     * @param certificate
     */
    function convertSubscriptionCertificateToXml(certificate: RdfeModel.SubscriptionCertificate): string;
    /**
     * Converts a xml string encoding of SubvscriptionCertificates into a SubscriptionCertificate array.
     * @param xml
     */
    function convertXmlToSubscriptionCertificates(xml: string): RdfeModel.SubscriptionCertificate[];
    /**
     * Converts a xml string encoding of a SubscriptionCertificate into the Javascript Object.
     * @param xml
     */
    function convertXmlToSubscriptionCertificate(xml: string): RdfeModel.SubscriptionCertificate;
    /**
     * Deep clone a javascript object
     * @param obj
     */
    function cloneObject(obj: Object): Object;
}
