import * as express from "express";
import * as Q from "q";
import { RdfeManager } from "./rdfeManager";
import { HttpsProxy } from "../HttpsProxy/httpsProxy";
export declare module RdfeProxy {
    interface RdfeExpressServer extends HttpsProxy.ExpressServer {
        /**
         * The instance of rdfe manager.
         */
        rdfeManager?: RdfeManager.Manager;
    }
    /**
     * Creates an rdfe proxy instance and setups firewal and certificates.
     *
     * @param rdfeEndpoint The rdfe endpoint to proxy.
     * @param serverPort The local server port.
     * @param rdfeManager The rdfe mock manager.
     * @param enablePassthrough If to enable passthrough to actual rdfe.
     * @return A promise that completes when local proxy is setup.
     */
    function create(rdfeEndpoint: string, serverPort: number, rdfeManager?: RdfeManager.Manager, customRoutes?: (app: express.Express) => void, enablePassthrough?: boolean): Q.Promise<HttpsProxy.ProxyServer>;
    /**
     * Dispose local proxy
     *
     * @param rdfeEndpoint The rdfe endpoint to proxy.
     * @param serverPort The local server port.
     * @param enablePassthrough If to enable passthrough to actual rdfe.
     * @return A promise that completes when local proxy is setup.
     */
    function dispose(proxy: HttpsProxy.ProxyServer): Q.Promise<any>;
}
